# Based on example from "Core Python Programming" book, chapter 20
# This is probably the smallest http server in the world
# Start it from a cmd.exe window with: python myhttpd.py
# To stop it: Control-C
# The point is: it works in Windows, Linux, Mac, and Android ...

import os, socket
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer

class MyHandler(BaseHTTPRequestHandler):
    def do_GET(self):
        try:
            f = open(os.curdir + os.sep + self.path)
            self.send_response(200)
            self.send_header("Content-type", "text/html")
            self.end_headers()
            self.wfile.write(f.read())
            f.close()
        except IOError:
            message = "File Not Found (MyServer): " + self.path
            self.send_error(404, message)

# If your are behind a firewall or a home LAN router
# you have no choice but try one of these to get your external IP
def getExternalIP():
    sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    sock.connect(('google.com', 80))
    ip, port = sock.getsockname()
    sock.close()
    return ip


#########  Starting the HTTP Server  #######################
my_host_name  = socket.gethostname()
#In normal hosts this is the way to get your IP address:
#my_IP_address = socket.gethostbyname(my_host_name)
#But if your are behind a firewall or a home LAN router
#use this:
my_IP_address = getExternalIP()

try:
    server = HTTPServer((my_IP_address, 80), MyHandler)
    # or you can use: server = HTTPServer(("localhost", 80), MyHandler)
    print "Welcome to my personnal web server!"
    print "My name is Yoram Hacker"
    print "My Host name is:", my_host_name
    print "My IP address is:", my_IP_address
    print "Press Control-C once or twice to quit"
    server.serve_forever()
except KeyboardInterrupt:
    print "Control-C received, shutting down server"
    server.socket.close()


